<?php
session_start();

$errorsb = 0;

/*Variables para mensajes de error*/
$_SESSION['e-usu'] = '';
$_SESSION['e-pass'] = '';
$_SESSION['e-pass2'] = '';
$_SESSION['e-mail'] = '';
$_SESSION['e-capt'] = '';

function validateUsername($name, $other){
    //NO cumple longitud minima
	if(strlen($name) < 4 || strlen($name) > 20){
		$_SESSION['e-usu'] = 'El usuario debe contener minimo 5 y maximo 20 caracteres ';
		return false;
    //SI longitud pero NO solo caracteres A-z
	}else if(!preg_match("/^[a-zA-Z]+$/", $name)){
		$_SESSION['e-usu'] = 'El usuario no puede contener caracteres especiales ';
		return false;
    // SI longitud, SI caracteres A-z
	}else{
		return true;
	}
}

function validatePassword1($password1){
	//NO tiene minimo de 5 caracteres o mas de 20 caracteres
	if(strlen($password1) < 5){
		$_SESSION['e-pass'] = '- La contrasea debe contener minimo 5 caracteres ';
		return false;
	}else if(strlen($password1) > 20){
		$_SESSION['e-pass'] = '- La contrasea debe contener maximo 35 caracteres ';
	// SI longitud, NO VALIDO numeros y letras
	}else if(!preg_match("/^[0-9a-zA-Z]+$/", $password1)){
		$_SESSION['e-pass'] = '- La contrasea debe contener letras y numeros ';
		return false;
	// SI longitud SI numeros y letras SI no espacios en blanco
	}else{
		return true;
	}
}

function validatePassword2($password1, $password2){
	//NO coinciden
	if($password1 != $password2){
		$_SESSION['e-pass2'] = '- Las contraseas ingresadas no coinciden' ;
		return false;
	}else{
		return true;
	}
}

function validateEmail($email){
	//NO hay nada escrito
	if(strlen($email) < 12 || strlen($email) > 45){
		$_SESSION['e-mail'] = '- EL correo electrnico debe contener minimo 12 y maximo 45 caracteres ';
		return false;
	// SI escrito, NO VALIDO email
	}else if(!filter_var($email, FILTER_VALIDATE_EMAIL)){
		$_SESSION['e-mail'] = '- Debe ingregar un correo electrnico vlido ';
		return false;
	// SI rellenado, SI email valido
	}else{
		return true;
	}
}

function validatecaptcha($capt){
	//NO coincide codigo
	if($capt != $_SESSION['string']){
		$_SESSION['e-capt'] = '- EL codigo de verificacin no coincide' ;
		return false;
	//SI codigo coincide
	}else{
		return true;
	}
}

/*Validacion de datos enviados*/
    if(!validateUsername(filter_var($_REQUEST['userid'], FILTER_SANITIZE_STRING)))
	{
		$_SESSION['inpt'] = '';
		++$errorsb;
	}
/*Validar contrasea*/
    if(!validatePassword1(filter_var($_REQUEST['pass'], FILTER_SANITIZE_STRING)))
	{
		++$errorsb;
	}
/*Validar coincidencia de contraseas*/
    if(!validatePassword2(filter_var($_REQUEST['pass'],FILTER_SANITIZE_STRING), filter_var($_REQUEST['pass2'], FILTER_SANITIZE_STRING)))
	{
    	++$errorsb;
	}
/*Valida Email*/
	if(!validateEmail(filter_var($_REQUEST['email'], FILTER_SANITIZE_EMAIL)))
	{
		++$errorsb;
	}
/*Valida capt*/
	if(!validatecaptcha(filter_var($_REQUEST['tmptxt'], FILTER_SANITIZE_STRING)))
	{
		++$errorsb;
	}

$_SESSION['id'] = $_POST["userid"];
$_SESSION['pass'] = $_POST["pass2"];
$_SESSION['email'] = $_POST["email"];	


//header("Location: registro.php");

if($errorsb > 0)
	{
	header("Location: registro.php");
	}
	else
	{
	header("Location: registroc6.php");	
	}
?>