<?php
//session_start();
require(dirname(__FILE__) . '/../panel_adm/reportes/fpdf.php');

class PDF extends FPDF{
    var $legends;
    var $wLegend;
    var $sum;
    var $NbVal;
	var $angle=0;
	protected $B = 0;
	protected $I = 0;
	protected $U = 0;
	protected $HREF = '';
	
	//cabecera
	function Header(){
		$this->SetFont('Arial','B',50);
		$this->SetTextColor(255,192,203);
		$this->RotatedText(20,180,'D o c u m e n t o    d e m o',45);
		// Logo
		$this->Image(dirname(__FILE__) . '/../images/rep_a4_hor.png',5,5,285);
		/*
		// Arial bold 15
		$this->SetFont('Arial','B',15);
		// Movernos a la derecha
		$this->Cell(80);
		// Título
		$this->Cell(30,10,'Title',1,0,'C');
		// Salto de línea
		$this->Ln(20); */
	}
	// Pie de página
	function Footer(){
		// Posición: a 1,5 cm del final
		$this->SetY(-20);
		// Arial italic 8
		$this->SetFont('Arial','I',7);
		// Número de página
		$this->Multicell(800,4, utf8_decode("PROSOL INVERSIONES SAC administra www.pagatudeuda.com cuyo objeto es encontrar soluciones de pago a problemas crediticios de mora para clientes que deseen cancelar sus obligaciones. Garantizamos privacidad y confidencialidad de su 
información, no compartiremos su información con otras personas ni con el tercero acreedor (Ley de Protección de Datos Personales 29733. Para encontrar las alternativas de solución usamos medios digitales y correos electrónicos, cumpliendo 
con la Ley N° 29493 que regula el uso del correo electrónico comercial no solicitado (SPAM). Su autorización y consentimiento otorgado será de beneficio exclusivo de/para usted, con la finalidad de mejorar su historial crediticio y reinserción en el 
sistema financiero, según el Acuerdo de Términos y Condiciones de Uso y Política de Privacidad. Para consultas escribanos a: atencionalcliente@prosol.com.pe"));
		//$this->SetXY(125,-20);
		//$this->SetFont('Arial','B',18);
		//$this->SetDrawColor(255,255,255);
		//$this->SetFillColor(0,0,130);
		//$this->SetTextColor(250,200,70);
		//$this->Cell(80,10,'www.pagatudeuda.com',1,0,'C',true);
		//$this->SetFont('Arial','I',7);
		//$this->Cell(0,10,'Page '.$this->PageNo().'/{nb}',0,0,'C');
	}
	
	function RotatedText($x, $y, $txt, $angle){
		//Text rotated around its origin
		$this->Rotate($angle,$x,$y);
		$this->Text($x,$y,$txt);
		$this->Rotate(0);
	}
	
	function Rotate($angle,$x=-1,$y=-1){
		if($x==-1)
			$x=$this->x;
		if($y==-1)
			$y=$this->y;
		if($this->angle!=0)
			$this->_out('Q');
		$this->angle=$angle;
		if($angle!=0){
			$angle*=M_PI/180;
			$c=cos($angle);
			$s=sin($angle);
			$cx=$x*$this->k;
			$cy=($this->h-$y)*$this->k;
			$this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
		}
	}
	
	function _endpage(){
		if($this->angle!=0){
			$this->angle=0;
			$this->_out('Q');
		}
		parent::_endpage();
	}
	
	function LoadData($file){
		// Leer las líneas del fichero
		$lines = file($file);
		$data = array();
		foreach($lines as $line)
			$data[] = explode(';',trim($line));
			//$aa = explode(';',trim($line));
			//print_r($aa);
			//exit;
		return $data;
	}
	// Tabla simple
	function BasicTable($header, $data){
		// Cabecera
		foreach($header as $col)
			$this->Cell(22,7,$col,1);
		$this->Ln();
		// Datos
		foreach($data as $row)	{
			foreach($row as $col)
				$this->Cell(22,6,$col,1);
			$this->Ln();
		}
	}
	// Una tabla más completa
	function ImprovedTable($header, $data){
		// Anchuras de las columnas
		$w = array(20, 20, 20, 12, 20, 18, 12, 20);
		// Cabeceras
		for($i=0;$i<count($header);$i++)
			$this->Cell($w[$i],7,$header[$i],1,0,'C');
		$this->Ln();
		// Datos
		foreach($data as $row){
			$this->Cell($w[0],6,$row[0],'LR');
			$this->Cell($w[1],6,$row[1],'LR');
			$this->Cell($w[2],6,$row[2],'LR');
			//$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R');
			$this->Cell($w[3],6,$row[3],'LR');
			//$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R');
			$this->Cell($w[4],6,$row[4],'LR');
			$this->Ln();
		}
		// Línea de cierre
		$this->Cell(array_sum($w),0,'','T');
	}

	function FancyTable($header1, $header2, $codcliente, $tablacompleta){
		// Colores, ancho de línea y fuente en negrita
		$this->SetFillColor(150,200,200); //fondo
		$this->SetTextColor(0,0,0);   //texto
		$this->SetDrawColor(0,0,0);    //bordes
		$this->SetLineWidth(.3);
		$this->SetFont('','B',6);
		//cabecera1
		$ac = array();
		for($i=0;$i<count($header1);$i++){
			$ac = explode('|',$header1[$i]);
			$this->Cell($ac[0],5,$ac[1],1,0,'C',true);
		}
		$this->Ln();
		// Cabecera2
		$w = array(); //el ancho de la cabecera2 define el ancho de la data
		$ac2 = array();
		for($i=0;$i<count($header2);$i++){
			$ac2 = explode('|',$header2[$i]);
			$this->Cell($ac2[0],5,$ac2[1],1,0,'C',true);
			$w[]=$ac2[0]; //agrego los anchos en el array
		}
		$this->Ln();
		
		// Restauración de colores y fuentes
		$this->SetDrawColor(255,255,255);
		$this->SetFillColor(224,235,255);
		$this->SetTextColor(0);
		$this->SetFont('Arial','',6);
		

		$nrofilas=mysql_num_rows($tablacompleta);
		if($nrofilas==0) $this->Cell(40,5,'NO HAY DATOS');
		else{
			while($fila=mysql_fetch_assoc($tablacompleta)){
				$idcartera=$fila["IdCartera"];
				$sqlResult=$class_report->genrepptd($codcliente,$idcartera);
				while ($detfila=mysql_fetch_array($sqlResult)) {
					$data[] = explode(';',trim($detfila["col"]));
					foreach($data as $row){
						for($col=0;$col<count($w);$col++) $this->Cell($w[$col],5,$row[$col],'LR',0,'L',$fill);
						$this->Ln();
						$fill = !$fill;
					}
				}
			}
			// Datos
			$fill = false;
			
			// Línea de cierre
			$this->Cell(array_sum($w),0,'','T');
		}
	}
	
	function SetCol($col){
		// Establecer la posición de una columna dada
		$this->col = $col;
		$x = 10+$col*65;
		$this->SetLeftMargin($x);
		$this->SetX($x);
	}

	function WriteHTML($html){
		// Intérprete de HTML
		$html = str_replace("\n",' ',$html);
		$a = preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
		foreach($a as $i=>$e){
			if($i%2==0){
				// Text
				if($this->HREF)
					$this->PutLink($this->HREF,$e);
				else
					$this->Write(5,$e);
			}else{
				// Etiqueta
				if($e[0]=='/')
					$this->CloseTag(strtoupper(substr($e,1)));
				else{
					// Extraer atributos
					$a2 = explode(' ',$e);
					$tag = strtoupper(array_shift($a2));
					$attr = array();
					foreach($a2 as $v){
						if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
							$attr[strtoupper($a3[1])] = $a3[2];
					}
					$this->OpenTag($tag,$attr);
				}
			}
		}
	}
	
	function OpenTag($tag, $attr){
		// Etiqueta de apertura
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,true);
		if($tag=='A')
			$this->HREF = $attr['HREF'];
		if($tag=='BR')
			$this->Ln(5);
	}
	
	function CloseTag($tag){
		// Etiqueta de cierre
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,false);
		if($tag=='A')
			$this->HREF = '';
	}

	function SetStyle($tag, $enable){
		// Modificar estilo y escoger la fuente correspondiente
		$this->$tag += ($enable ? 1 : -1);
		$style = '';
		foreach(array('B', 'I', 'U') as $s){
			if($this->$s>0)
				$style .= $s;
		}
		$this->SetFont('',$style);
	}

	function PutLink($URL, $txt){
		// Escribir un hiper-enlace
		$this->SetTextColor(0,0,255);
		$this->SetStyle('U',true);
		$this->Write(5,$txt,$URL);
		$this->SetStyle('U',false);
		$this->SetTextColor(0);
	}
	//graficos
	function ColumnChart($w, $h, $data2, $format, $color=null, $maxVal=0, $nbDiv=12){
        // RGB for color 0
        $colors[0][0] = 155;
        $colors[0][1] = 75;
        $colors[0][2] = 155;
        // RGB for color 1
        $colors[1][0] = 0;
        $colors[1][1] = 155;
        $colors[1][2] = 0;
        // RGB for color 2
        $colors[2][0] = 75;
        $colors[2][1] = 155;
        $colors[2][2] = 255;
        // RGB for color 3
        $colors[3][0] = 75;
        $colors[3][1] = 0;
        $colors[3][2] = 155;

        $this->SetFont('Courier', '', 10);
        $this->SetLegends($data2,$format);
		// Starting corner (current page position where the chart has been inserted)
        $XPage = $this->GetX();
        $YPage = $this->GetY();
        $margin = 2; 
        // Posición Y del gráfico
        $YDiag = $YPage + $margin;
        // Gráfico ALTURA
        $hDiag = floor($h - $margin * 2);
        // posición X del gráfico
        $XDiag = $XPage + $margin;
        // Gráfico LARGO
        $lDiag = floor($w - $margin * 3 - $this->wLegend);

        if($color == null) $color=array(155,155,155);
        if ($maxVal == 0){
            foreach($data2 as $val){
                if(max($val) > $maxVal){
                    $maxVal = max($val);
                }
            }
        }
        // Definir la distancia entre las líneas de referencia visuales (las líneas que cruzan el área interna del gráfico y servir como referencia visual para las alturas de la columna)
        $valIndRepere = ceil($maxVal / $nbDiv);

        // Ajustar el valor máximo a trazar (recalcular a través de la nueva distancia calculada entre las líneas de referencia visuales)
        $maxVal = $valIndRepere * $nbDiv;
			
        // Definir la distancia entre las líneas de referencia visuales (en milímetros)
        $hRepere = floor($hDiag / $nbDiv);

        // Ajustar la ALTURA del gráfico
        $hDiag = $hRepere * $nbDiv;

        // Determinar la unidad de altura (milimetros / unidad de datos)
        $unit = $hDiag / $maxVal;
			
        // determine the bar's thickness
        $lBar = floor($lDiag / ($this->NbVal + 1));
        $lDiag = $lBar * ($this->NbVal + 1);
        $eColumn = floor($lBar * 80 / 100);

        // draw the chart border
        $this->SetLineWidth(0.2);
        $this->Rect($XDiag, $YDiag, $lDiag, $hDiag);

        $this->SetFont('Courier', '', 10);
        $this->SetFillColor($color[0],$color[1],$color[2]);
        $i=0;

		//print_r($valIndRepere);
		//exit;
		
        foreach($data2 as $val){
            //Column
            $yval = $YDiag + $hDiag;
            $xval = $XDiag + ($i + 1) * $lBar - $eColumn/2;
            $lval = floor($eColumn/(count($val)));
            $j=0;

            foreach($val as $v){
                $hval = (int)($v * $unit);
                $this->SetFillColor($colors[$j][0], $colors[$j][1], $colors[$j][2]);
                $this->Rect($xval+($lval*$j), $yval, $lval-1, -$hval, 'DF');
                $j++;
            }
            //Legend
            $this->SetXY($xval, $yval + $margin);
            $this->Cell($lval, 5, $this->legends[$i],0,0,'C');
			//$this->Cell($lval, 5, $xval,0,0,'C');
			//$this->Cell($lval, 5, 1,0,0,'C');
            $i++;
        }

        //Scales
        for ($i = 0; $i <= $nbDiv; $i++){
            $ypos = $YDiag + $hRepere * $i;
            $this->Line($XDiag, $ypos, $XDiag + $lDiag, $ypos);
            $val = ($nbDiv - $i) * $valIndRepere;
            $ypos = $YDiag + $hRepere * $i;
            $xpos = $XDiag - $margin - $this->GetStringWidth($val);
            $this->Text($xpos, $ypos, $val);
        }
    }

	function SetLegends($data2, $format){
        $this->legends=array();
        $this->wLegend=0;
        $this->NbVal=count($data2);
    }
	
}

function crearpdf($ruta){
	if(isset($_SESSION["dacds"]) && count($_SESSION["dacds"]) >= 1){
		$datos = new Datos();
		//declaracion de la clase:
		//$pdf = new PDF(); //por default vertical;
		$pdf = new PDF('L','mm','A4');  //para horizontal
		$pdf->SetMargins(5, 5, 0);   
		$pdf->AddPage();
		$pdf->Ln(35);
		$pdf->SetFont('Arial','B',7);
		$pdf->Cell(40,5,'Sr(a) '. (isset($_SESSION["cli"]["0"]["Nombre"]) ? $_SESSION["cli"]["0"]["Nombre"] : ""));
		
		$pdf->Ln(5);
		/*$pdf->MultiCell(800,4,utf8_decode('Adjuntamos  Carta  de  Instrucción  de  su  Acuerdo  de  Pago,  agradeceremos  se  sirva  realizar  su(s)  depósito(s)  en  cta.cte.  en  soles  BBVA  0011-0142-0100091030  de  PROSOL 
INVERSIONES SAC. Consigne  su nombre completo o su DNI. Realizado su pago, coordinar y/o comunicarse en nuestra oficina en Jr. Bolognesi 160 Dpto. 402 San Miguel, Lima de 
lunes a viernes de 7 a 7pm y sábados de 9 a 1pm o comunicarse al 2635181 o 997501488 o 997806801 para la entrega de su <u><B>Carta de No Adeudo</B></u>, o visite  www.prosol.com.pe  o 
www.pagatudeuda.com, o escribanos a: atencionalcliente@prosol.com.pe. Si Ud. es cliente de provincias, se le enviara sus documentos en la ciudad solicitada. Para regularizar el 
estatus de su crédito cancelado ante la entidad financiera originadora y/o la SBS, solicite las instrucciones.'));*/
		
		$html = utf8_decode('<p align="justify">Adjuntamos  Carta  de  Instrucción  de  su  Acuerdo  de  Pago,  agradeceremos  se  sirva  realizar  su(s)  depósito(s)  en  cta.cte.  en  soles  BBVA  0011-0142-0100091030  de  PROSOL 
INVERSIONES SAC. Consigne  su nombre completo o su DNI. Realizado su pago, coordinar y/o  comunicarse en nuestra oficina en Jr. Bolognesi 160 Dpto. 402  San Miguel, Lima de 
lunes a viernes de 7 a 7pm y sábados de 9 a 1pm o comunicarse al 2635181 o 997501488 o 997806801 para  la entrega de su <u><B>Carta de No Adeudo</B></u>, o  visite  www.prosol.com.pe  o 
www.pagatudeuda.com, o  escribanos a:  atencionalcliente@prosol.com.pe. Si Ud. es cliente de  provincias, se  le enviara sus  documentos en la ciudad  solicitada. Para regularizar el 
estatus de su crédito cancelado ante la entidad financiera originadora y/o la SBS, solicite las instrucciones. </p>');
		$pdf->WriteHTML($html);
		$pdf->Ln(5);
		$pdf->SetFont('Arial','B',7);
		// Colores, ancho de línea y fuente en negrita
		$pdf->SetFillColor(150,200,200); //fondo
		$pdf->SetTextColor(0,0,0);   //texto
		$pdf->SetDrawColor(0,0,0);    //bordes
		$pdf->SetLineWidth(.3);
		$pdf->SetFont('Arial','B',6);
		$pdf->Cell(20,5,'Negocio Nro',1,0,'C',true);
		$pdf->Cell(15,5,'Tipo Negoc',1,0,'C',true);
		$pdf->Cell(15,5,'Fecha',1,0,'C',true);
		$pdf->Cell(15,5,'F.V.',1,0,'C',true);
		$pdf->Cell(20,5,'Originador',1,0,'C',true);
		$pdf->Cell(20,5,'Cartera',1,0,'C',true);
		$pdf->Cell(20,5,'Acreedor',1,0,'C',true);
		$pdf->Cell(30,5,'Prod',1,0,'C',true);
		$pdf->Cell(20,5,'Sldo Act',1,0,'C',true);
		$pdf->Cell(20,5,'Valor Negoc',1,0,'C',true);
		$pdf->Cell(15,5,'Inicial',1,0,'C',true);
		$pdf->Cell(15,5,'Cuotas',1,0,'C',true);
		$pdf->Cell(15,5,'Mensual',1,0,'C',true);
		$pdf->Cell(15,5,'Obs.',1,0,'C',true);
		$pdf->Ln();

		// Restauración de colores y fuentes
		$pdf->SetDrawColor(255,255,255);
		$pdf->SetFillColor(224,235,255);
		$pdf->SetTextColor(0);
		$pdf->SetFont('Arial','',6);
		$tot=0;
		$idneg="";
		foreach($_SESSION["dacds"] as $dacds ){
			$idneg.="'".$dacds["16"]."'";
			$tot++;
			if($tot<count($_SESSION["dacds"])){
				$idneg.=",";
			}
			//$pdf->Cell(20,5,$dacds["16"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["1"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["2"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["3"],1,0,'C',true);
			//$pdf->Cell(20,5,$dacds["5"],1,0,'C',true);
			//$pdf->Cell(30,5,$dacds["4"],1,0,'C',true);
			//$pdf->Cell(20,5,$dacds["7"],1,0,'C',true);
			//$pdf->Cell(20,5,$dacds["10"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["12"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["11"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["13"],1,0,'C',true);
			//$pdf->Cell(15,5,$dacds["14"],1,0,'C',true);
			//$tot=$tot+$dacds["15"];
			//$pdf->Ln();
		}
		$CadSql="SELECT w_acpago.acu_cdn,w_acpago.acu_dacu,w_acpago.acu_f_ac,w_acpago.acu_fv_ac,carteras.Originador,carteras.NomCartera,carteras.Acreedor,w_dacpag.dac_prd,w_acpago.acu_dt_act,w_acpago.acu_mn_pac,w_acpago.acu_mn_cini,w_acpago.acu_cts,w_acpago.acu_ct_men,w_acpago.acu_mtv FROM w_acpago INNER JOIN w_dacpag ON w_acpago.acu_id_ac=w_dacpag.dac_id_ac INNER JOIN carteras ON w_dacpag.dac_bnc=carteras.NomCartera WHERE w_acpago.acu_cdn IN (".$idneg.")";
		$rs=$datos->ListarDatos($CadSql);
		while($fila=mysql_fetch_assoc($rs)){
			$pdf->Cell(20,5,$fila["acu_cdn"],1,0,'C',true);  //Negocio Nro
			$pdf->Cell(15,5,$fila["acu_dacu"],1,0,'C',true);  //Tipo Negoc
			$pdf->Cell(15,5,$fila["acu_f_ac"],1,0,'C',true);  //Fecha
			$pdf->Cell(15,5,$fila["acu_fv_ac"],1,0,'C',true);  //F.V.
			$pdf->Cell(20,5,$fila["Originador"],1,0,'C',true);  //originador
			$pdf->Cell(20,5,$fila["NomCartera"],1,0,'C',true);  //Cartera
			$pdf->Cell(20,5,$fila["Acreedor"],1,0,'C',true);   //acreedor
			$pdf->Cell(30,5,$fila["dac_prd"],1,0,'C',true);   //Producto
			$pdf->Cell(20,5,$fila["acu_dt_act"],1,0,'C',true); //Sldo Act
			$pdf->Cell(20,5,$fila["acu_mn_pac"],1,0,'C',true);  //Valor Negoc  monto pactado
			$pdf->Cell(15,5,$fila["acu_mn_cini"],1,0,'C',true);  //Inicial
			$pdf->Cell(15,5,$fila["acu_cts"],1,0,'C',true);  // numero de Cuotas
			$pdf->Cell(15,5,$fila["acu_ct_men"],1,0,'C',true);   //importe de cuota
			$pdf->Cell(15,5,$fila["acu_mtv"],1,0,'C',true);     //observacion   motivo
			$tot=$tot+$fila["acu_mn_pac"];
			$pdf->Ln();
		}

		$pdf->Ln();
		$pdf->Cell(115,5,'',1,0,'C',true);
		// Colores, ancho de línea y fuente en negrita
		$pdf->SetFillColor(150,200,200); //fondo
		$pdf->SetTextColor(0,0,0);   //texto
		$pdf->SetDrawColor(0,0,0);    //bordes
		$pdf->SetLineWidth(.3);
		$pdf->SetFont('Arial','B',6);
		$pdf->Cell(20,5,'Total',1,0,'C',true);
		$pdf->Cell(20,5,$tot,1,0,'C',true);
		// Restauración de colores y fuentes
		$pdf->SetDrawColor(255,255,255);
		$pdf->SetFillColor(224,235,255);
		$pdf->SetTextColor(0);
		$pdf->SetFont('Arial','',6);
		$pdf->Cell(60,5,'',1,0,'C',true);
		$pdf->Output('/var/www/prosol/negocios/negocio.pdf','F');
	}
}

/*
$a = array();
$a[0][0] = "1";
$a[0][1] = "1";
$a[0][2] = "1";
$a[0][3] = "1";
$a[0][4] = "1";
$a[0][5] = "1";
$a[0][6] = "1";
$a[0][7] = "1";
$a[0][8] = "y";
$a[0][9] = "z";
$a[0][10] = "1";
$a[0][11] = "1";
$a[0][12] = "1";
$a[0][13] = "1";
$a[0][14] = "1";
$a[0][15] = "1";
$a[0][16] = "1";
$a[1][0] = "1";
$a[1][1] = "1";
$a[1][2] = "1";
$a[1][3] = "1";
$a[1][4] = "1";
$a[1][5] = "1";
$a[1][6] = "1";
$a[1][7] = "1";
$a[1][8] = "y";
$a[1][9] = "z";
$a[1][10] = "1";
$a[1][11] = "1";
$a[1][12] = "1";
$a[1][13] = "1";
$a[1][14] = "1";
$a[1][15] = "1";
$a[1][16] = "1";

print_r($a);
$_SESSION["dacds"]=$a;

crearpdf("");
*/
?>