#!/usr/bin/python

#################################################################################################################
#                                                                                                               #
# Archivo:     sms_test.py                                                                                      #
# Descripcion: Este script escrito en Python realiza el envio de mensajes de texto leidos desde un archivo      #
#              CSV. Primero encola todos los mensajes y luego verifica el estado de cada uno hasta que fallen   #
#              o sean enviados correctamente.                                                                   #
# Autor:       Yx Wireless                                                                                      #
# Mas info:    Revisar documentacion API Web.                                                                   #
#                                                                                                               #
#################################################################################################################
#                                                                                                               #
# Para ejecutar este script de prueba de la API Web:                                                            #
#     sms_test <archivo.csv>                                                                                    #
#                                                                                                               #
# Donde <archivo.csv> es un archivo que contiene mensajes a enviar con el siguiente formato:                    #
#         num_destino1;contenido1                                                                               #
#         num_destino2;contenido2                                                                               #
#         num_destino3;contenido3                                                                               #
#              ...    ;    ...                                                                                  #
#                    etc                                                                                        #
#                                                                                                               #
#################################################################################################################

from subprocess import *;
#import json
import simplejson as json
import urllib
import csv
import sys
import time
import MySQLdb

# Username en el servidor web del equipo
web_user = 'admin'

# Password en el servidor web del equipo
web_pass = 'l1r5c'

# IP del equipo
lyric_ip = '192.168.1.252'

# Nombre de usuario de la API
api_user = 'lyric_api'

# Password de la API
api_pass = '4b0g4d0s'

# Version de la API Web soportada por el equipo
# Se puede obtener utilizando el comando api_get_version
api_version = '0.08'

# Ubicacion del CGI que implementa las funciones de la API
url = "http://" + web_user + ":" + web_pass + "@" + lyric_ip + "/cgi-bin/exec"

# IP de la base de datos
hostname = 'localhost'

# Nombre de la base de datos
dbname = 'efnsms'

# Usuario de base de datos
userdb = 'root'

# Contrasena de usuario de base de datos
passwdb = 'usu4r1o_mysq1_3ff1n3t'

# Clase que implementa la estructura y principales funciones de un SMS
# Atributos
#     estado: Estado en el que se encuentra el mensaje
#                    -1: Mensaje no iniciado
#                     0: Nuevo
#                     1: Procesando
#                     2: Enviado
#                     3: Fallo
#     contenido: Contenido del SMS
#     destino: Numero del destino
#     message_id: Ticket que identifica el mensaje
#
# Metodos
#     queue: Encola el mensaje utilizando el comando api_queue_sms de la API Web
#     get_status: Obtiene el estado actual del mensaje utilizando el comando api_get_status de la API Web
#
#     Los argumentos para invocar ambos metodos son los mismos:
#            url: Considera datos de autentificacion a servidor web y ruta del CGI que ejecuta los comandos API
#            api_user, api_pass: Autentificacion a API web
#            api_version: Version de API web que soporta el equipo
#
# Iniciacion
#     Cada mensaje se inicia como: msg = Mensaje(destino, contenido)
#
# Errores
#     En caso de que ocurra un error en los metodos, estos son escritos en la salida estandar. Revisar documentacion API Web.

# Creamos la clase mensaje
class Mensaje:
#	 Definimos el valor de las variables por defecto,
#	 notese que algunas variables por defecto tendran
#	 valor de "-1", esto es util para comparacion en
#	 los if mas adelante
    estado = -1
    contenido = ""
    destino = ""
    message_id = -1
#	 Funcion por defecto __init_, esta funcion siempre se
#	 ejecutara por defecto al llamar a la clase, lo que hacemos
#	 en la funcion por defecto es obtener los parametros que
#	 sean pasados a la clase (si es que fueron pasados),
#	 y establecerlos en 2 variables "destino y contenido",
#	 luego asignaremos el valor de estas variables a las
#	 variables establecidas al inicio de la clase, que
#	 coincidentemente se llaman de la misma forma: "destino
#	 y contenido y a las cuales asignamos valor de vacio
    def __init__(self, destino, contenido):
        self.estado = 0
        self.destino = destino
        self.contenido = contenido
#	 metodo queue, este metodo sirve para poner en cola un mensaje
#	 recibe los parametros de conexion de la api, y toma los valores
#	 correspondientes al mensaje, de las vaiables iniciales de la
#	 clase, las cuales son: "destino y contenido"
    def queue(self, url, api_user, api_pass, api_version):
#		  Definimos la api a utilizar con los argumentos necesarios para llamarla
        args = urllib.urlencode({'cmd': 'api_queue_sms', 'username': api_user, 'password': api_pass, 'content': self.contenido, 'destination': self.destino, 'api_version': api_version})
#		  activar para depurar
#       print args
#		  Ejecutamos los argumentos mediante url, lo cual llamara a la api
#		  y realizara los procedimientos de la misma, y almacenamos resultado
#		  en variable
        res = urllib.urlopen(url + '?' + args).read()
#		  Formateamos el resultado en json 
        obj = json.loads(res)
#		  Declaramos variable que tendra el estado que se devolvera al final de
#		  esta funcion y le asignamos valor de uno por defecto, recordar
#		  que por un tema de orden, si la funcion falla tendremos que devolver
#		  un -1, de lo contrario devolvemos un 1, esto lo hacemos para dejar
#		  la posibilidad de evaluar esta funcion con un if, si arroja 1 es
#		  verdadero, de lo contrario si arroja -1,e s falso
        res = 1
#		
#		  Evaluaremos el resultado de la api que fue llamada, para ello, basta
#		  con evaluar la variable que tiene el resultado
        if obj['success']:
            mensajes[i].estado = 0
            self.message_id = obj['message_id']
#				Preparamos la cadena a insertar en la db
            sqlinsrt = """INSERT INTO `efnsms`.`sms` (`efnsms_id`, `efnsms_num`, `efnsms_msg`) VALUES ('%s', '%s', '%s');""" % (self.message_id, self.destino, self.contenido)
#				activar para depurar
#            print 'Mensaje insertado exitosamente. Ticket: ' + str(obj['message_id'])
        else:
            mensajes[i].estado = -1
            errcola = obj['error_code']
#				Preparamos la cadena a insertar en la db
            sqlinsrt = """INSERT INTO `efnsms`.`sms` (`efnsms_id`, `efnsms_num`, `efnsms_msg`, `efnsms_err`) VALUES ('%s', '%s', '%s', '%s');""" % (self.message_id, self.destino, self.contenido, errcola)
            print sqlinsrt
#				activar para depurar
#            print 'Error al insertar mensaje. Codigo de error: ' + obj['error_code']
            res = -1
#		  Insertamos en la db el mensaje de texto con su respectivo id, primero,
#		  realizamos la conexion de la db
        db = MySQLdb.connect(hostname, userdb, passwdb, dbname)
#		  Establecemos el cursor, el cual nos permitira ingresar datos en la db 		  
        cursor = db.cursor()
#		  Ejecutamos la consulta con la db
        cursor.execute(sqlinsrt)
#		  Retornamos el resultado de la funcion
        return res
#	 Metodo get_status, este metodo retorna el estado del sms en la cola valiendose
#	 del id de cada mensaje y los parametros de la api
    def get_status(self, url, api_user, api_pass, api_version):
#		  Primero evaluamos si el estado es -1 o mayor igual que 2 (la segunda comparacion
#			con el "2", la hacemos porsiacaso) 
#        if self.estado == -1 or self.estado >= 2:
#				Salimos de la funcion retornando el estado, debido a que si el estado es -1,
#				significa que el mensaje no tiene id y por lo tanto fallo al ser insertado
#				en la cola, por lo tanto esta de mas seguir ejecutando la funcion
#            return self.estado
#		  Si paso la validacion anterior, preparamos la api a utilizar con los argumentos
#		  necesarios para llamarla       
        args = urllib.urlencode({'cmd': 'api_get_status', 'message_id': self.message_id, 'username': api_user, 'password': api_pass, 'api_version': api_version})
#		  Ejecutamos los argumentos mediante url, lo cual llamara a la api
#		  y realizara los procedimientos de la misma, y almacenamos resultado
#		  en variable
        res = urllib.urlopen(url + '?' + args).read()
#		  Formateamos el resultado en json
        obj = json.loads(res)
#		  Definimos variable que tendra cadena final devuelta por funcion
        rslt = ''
#		  Definimos variable contenedora de error
        smserr = ''
#		  Evaluamos el resultado de la consulta a la api acerca del estado del sms,
#		  si el resultado fue exitoso:
        if obj['success']:
            self.estado = obj['message_status']
#				Activar para depurar
#            print 'Ticket: ' + str(self.message_id) + ' Estado: ' + str(self.estado)
#				Aca podemos depurar la cadena completa que regresa el metodo de la api,
#				'api_get_status' y ver lo que contiene
#            print 'Ticket: ' + str(obj)
#				Retornamos el estado del mensaje
#            return obj['message_status']
#				Evaluamos el estado del mensaje, y segun el estado, iremos
#				almacenando el mensaje de estado, primero si el estado es
#				1 o 0 (New o Processing, segun la api en el pdf)
            if obj['message_status'] == 1 or obj['message_status'] == 0:
#					Establecemos mensaje informando que sms se est enviando
               est = ' El mensaje esta en cola '
#				Si estado es igual a 2 (sent, segun la api en el pdf)
            elif obj['message_status'] == 2:
#					Establecemos mensaje de enviado
               est = ' Mensaje enviado '
#				Si estado es igual a 3 (Failure, segun la api en el pdf)
            elif obj['message_status'] == 3:
#					Establecemos mensaje de error
               est = ' No se pudo enviar el mensaje '
#					Solo en este caso, estableceremos la variable con el
#					error arrojado por el sistema
               smserr = obj['error_code']
#				Establecemos el estado del mensaje en variable
            cad = obj['message_status']
#				Activar para depurar
#            cad2 = str(obj['num']) + est + str(time.strftime("%d-%m-%y-%H-%M-%S")) + ' Puerto=' + str(obj['channel'])
#            rslt = [cad,cad2]
#            print rslt
#            return str(obj['num']) + ' Mensaje Enviado ' + str(time.strftime("%d-%m-%y-%H-%M-%S")) + ' Puerto=' + str(obj['channel'])
#				Vamos estableciendo los valores que nos combiene en variables
#				para array final resultante, recordar que los valores arrojados
#				por la api, son enteros por eso es necesario convertirlos en cadena
#				"str" luego de obtenerlos, primero numero
            num = str(obj['num'])
#				Luego puerto
            txprt = ' Puerto='
            prt = str(str(obj['channel']))
#				Fecha de recepcion del mensaje en la cola
            smsfrcp = str(obj['recv_date'])
#				Fecha de envio del mensaje
            smsfenv = str(obj['send_date'])
#				Ultimo error producido
            smsuerr = str(obj['last_error'])
#				Establecemos la fecha en la que obtenemos la consulta y la convertimos
#				en cadena
            fech = str(time.strftime("%d-%m-%y-%H-%M-%S"))
#				Preparamos la cadena para insertar en la db
            sqlinsrt = """UPDATE `efnsms`.`sms` SET `efnsms_fins`='%s',`efnsms_est`='%s',`efnsms_err`='%s',`efnsms_fenv`='%s',`efnsms_can`='%s' WHERE `efnsms_id`='%s';""" % (smsfrcp, str(obj['message_status']), smsuerr, smsfenv, prt, self.message_id)
#				Insertamos en la db el mensaje de texto con su respectivo id, primero,
#				realizamos la conexion de la db
            db = MySQLdb.connect(hostname, userdb, passwdb, dbname)
#				Establecemos el cursor, el cual nos permitira ingresar datos en la db 		  
            cursor = db.cursor()
#				Ejecutamos la consulta con la db
            cursor.execute(sqlinsrt)
#				Asignamos al array resultante los valores anteriormente obtenidos
#            rslt = [cad,num,est,fech,prt]
            rslt = [str(cad),str(num),str(est),str(smsfrcp),str(smsfenv),str(smsuerr),str(smserr),str(txprt),str(prt),self.message_id]
            print rslt
#				Finalmente retornamos el array final resultante
            return rslt
#		  De lo contrario si el resultado no fue exitoso:
        else:
#				Activar para depurar
#            print 'Error al consultar estado. Codigo de error: ' + obj['error_code']
#				Retornamos error
            return -1
#	Metodo para obtener el id de un sms puesto en la cola
    def get_id(self):
#		Consultamos el id establecido
    	smsid = self.message_id
#		Retornamos el id
    	return smsid 
# Obtiene archivo CSV desde el primer argumento de la llamada a sms_test
file = sys.argv[1]

# Abre el archivo como CSV con separador ";"
csvfile = csv.reader(open(file), delimiter=';')

# Inicializa un arreglo vacio con un indice numero que ira incrementando,
# en el cual se iran insertando todos los mensajes descritos en el archivo CSV para encolarlos
mensajes = range(0)

# Declaramos contador
i = 0
# Realizamos bucle que recorrera cada fila en el archivo csv
for row in csvfile:
#	 Creamos un nuevo objeto llamado "mensajes" que obtendra sus atributos de la clase
#	 Llamamos a la clase "Mensajes", la cual tambien al llamarla, establecera los
#	 parametros por defecto del mesaje y le enviamos como parametro el destino y contenido
#	 del mensaje 
    mensajes.append(Mensaje(row[0], row[1]))
#	 Llamamos al metodo de la clase mensaje, llamado queue, el cual pondra en cola el
#	 mensaje 
    mensajes[i].queue(url, api_user, api_pass, api_version)
#	 Debido a que deseamos monitorear en tiempo real el estado de la cola, llamamos a
#	 el metodo get_status, para ir monitoreando cada mensaje en el proceso de ingresarlo
#	 en la cola de envio
    estado = mensajes[i].get_status(url, api_user, api_pass, api_version)
#	 Abrimos el archivo log para editar
    log = open('/var/www/servicesmsabo/msvlog/msv.log','a')
#	 Escribimos el estado del mensaje en el archivo log
    log.write(str(i)+' - '+estado[1]+estado[2]+estado[4]+estado[7]+estado[8]+'\n')
#	 Cerramos el archivo
    log.close()
#	 Aumentamos contador en uno
    i = i + 1

# Declaramos variable contenedora de estado
all_done = False
# Declaramos contador
j = -1
# Monitorea todos los mensajes encolados exitosamente y espera hasta que
# cada uno sea enviado o falle
while not all_done:
#	 Establecemos el valor de la variable de estado en verdadero
    all_done = True
#	 Realizamos un bucle que recorrera todos los mensajes
#    for g in range(len(mensajes)):
    while j < len(mensajes)-1:
#		  Preparamos cadena para consultar el sms en el sistema
        sqlsmslid = """SELECT `efnsms_est` from `efnsms`.`sms` WHERE `efnsms_id`='%s';""" % (mensajes[j].get_id())
#       #realizamos la conexion de la db
        db = MySQLdb.connect(hostname, userdb, passwdb, dbname)
#		  Establecemos el cursor, el cual nos permitira ingresar datos en la db 		  
        cursor = db.cursor()
#		  Ejecutamos la consulta con la db
        cursor.execute(sqlsmslid)
#		  Pasamos toda la data obtenida a una variable
        smsest = cursor.fetchall()
#		  se continua el bucle
#        print sqlsmslid
#        print j
#        print len(mensajes)-1
        if smsest != 0 and smsest != 1 and smsest != 2 and smsest != 3 and smsest != -1:
#			  Aumentamos contador en uno
           j += 1
#			   Llamamos al metodo que nos devuelve el estado del emsaje
           estado = mensajes[j].get_status(url, api_user, api_pass, api_version)
#			  Activar para depurar
#           print estado[0]
#           print all_done	
#			  Abrimos el archivo log para editar
           log = open('/var/www/servicesmsabo/msvlog/msv.log','a')
#			  Escribimos el contenido deseado
#     	  log.write(str(i)+' - '+estado[1]+estado[2]+estado[4]+estado[3]+'\n')
           log.write(str(j)+' - '+estado[1]+estado[2]+estado[4]+estado[7]+estado[8]+'\n')
#			  Cerramos el archivo
           log.close()
#			  Evaluamos el estado, si es "0" o "1", no se ha enviado,

           if estado[0] == "0" or estado[0] == "1":
#					Establecemos variable contenedora de estado en false
               all_done = False
# 					Restamos un valor al contador
               j = j - 1
#					Realizamos una pausa de 1 segundo
               time.sleep(1)
#					aumentamos el contador en uno
               break
        else:
           j += 1